﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ImageComparer
{
    public enum EventType {Error, Compared, End, Susspend, Resume };
    
    public class ImageComparerEventArgs : EventArgs
    {
       public int filesCount;
       public int comparedCount; 
       public int comparedCount2; 
       public Exception exception;
       public Dictionary<String, String> similarImagesPaths; 
       public EventType eventType;

       public ImageComparerEventArgs(int inFilesCount, int inComparedCount, EventType inEventType)
       {
           this.filesCount = inFilesCount;
           this.comparedCount = inComparedCount;
           this.eventType = inEventType;
       }
       public ImageComparerEventArgs(Exception inException, EventType inEventType)
       {
           this.exception = inException;
           this.eventType = inEventType;
       }
       public ImageComparerEventArgs(int inFilesCount, int inComparedCount, Dictionary<String, String> inSimilarImagesPaths, EventType inEventType)
       {
           this.filesCount = inFilesCount;
           this.comparedCount = inComparedCount;
           this.similarImagesPaths = inSimilarImagesPaths;
           this.eventType = inEventType;
       }

    }
}
